glibmm: Gio::UnixConnection Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::UnixConnection Class Reference
Portable Network I/O Functionality

A Unix domain SocketConnection. More...

`#include <giomm/unixconnection.h>`

Inheritance diagram for Gio::UnixConnection:
[legend]

## Public Member Functions
virtual | ~UnixConnection ()
GUnixConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GUnixConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GUnixConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | send_fd (int fd, const Glib::RefPtr< Cancellable >& cancellable)
| Passes a file descriptor to the receiving side of the connection. More...
bool | send_fd (int fd)
| A send_fd() convenience overload. More...
int | receive_fd (const Glib::RefPtr< Cancellable >& cancellable)
| Receives a file descriptor from the sending end of the connection. More...
int | receive_fd ()
| A receive_fd() convenience overload. More...
Glib::RefPtr< Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Receives credentials from the sending end of the connection. More...
Glib::RefPtr< Credentials > | receive_credentials ()
| A receive_credentials() convenience overload. More...
Glib::RefPtr< const Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable) const
| Receives credentials from the sending end of the connection. More...
Glib::RefPtr< const Credentials > | receive_credentials () const
| A receive_credentials() convenience overload. More...
void | receive_credentials_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable)
| Asynchronously receive credentials. More...
void | receive_credentials_async (const SlotAsyncReady& slot)
| A non-cancellable version of receive_credentials_async(). More...
Glib::RefPtr< Credentials > | receive_credentials_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous receive credentials operation started with g_unix_connection_receive_credentials_async(). More...
bool | send_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Passes the credentials of the current user the receiving side of the connection. More...
bool | send_credentials ()
| A send_credentials() convenience overload. More...
void | send_credentials_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable)
| Asynchronously send credentials. More...
void | send_credentials_async (const SlotAsyncReady& slot)
| A non-cancellable version of send_credentials_async(). More...
bool | send_credentials_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous send credentials operation started with g_unix_connection_send_credentials_async(). More...
Public Member Functions inherited from Gio::SocketConnection
virtual | ~SocketConnection ()
GSocketConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address, const Glib::RefPtr< Cancellable >& cancellable)
| Connect connection to the specified remote address. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address)
| A connect() convenience overload. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable)
| Asynchronously connect this connection to the specified remote address. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot)
| A non-cancellable version of connect_async(). More...
bool | connect_finish (const Glib::RefPtr< AsyncResult >& result)
| Gets the result of a g_socket_connection_connect_async() call. More...
bool | is_connected () const
| Checks if connection is connected. More...
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection. More...
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket. More...
Public Member Functions inherited from Gio::IOStream
virtual | ~IOStream ()
GIOStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream* | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::SocketConnection
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr < SocketConnection > | create (const Glib::RefPtr< Socket >& socket)
| Creates a SocketConnection subclass of the right type for socket. More...
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous io stream splice operation. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixConnection > | wrap (GUnixConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::SocketConnection
Glib::RefPtr < Gio::SocketConnection > | wrap (GSocketConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()

## Detailed Description

A Unix domain SocketConnection.

This is the subclass of SocketConnection that is created for UNIX domain sockets.

It contains functions to do some of the unix socket specific functionallity like passing file descriptors.

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::UnixConnection::~UnixConnection | ( |  | ) |
| virtual

## Member Function Documentation

static GType Gio::UnixConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GUnixConnection* Gio::UnixConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Glib::RefPtr<Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters

  cancellable | A Cancellable or `0`.

Returns
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

Glib::RefPtr<Credentials> Gio::UnixConnection::receive_credentials | ( |  | ) |

A receive_credentials() convenience overload.

Glib::RefPtr<const Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) | const

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters

  cancellable | A Cancellable or `0`.

Returns
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

Glib::RefPtr<const Credentials> Gio::UnixConnection::receive_credentials | ( |  | ) | const

A receive_credentials() convenience overload.

void Gio::UnixConnection::receive_credentials_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Asynchronously receive credentials.

For more details, see receive_credentials() which is the synchronous version of this call.

When the operation is finished, slot will be called. You can then call receive_credentials_finish() to get the result of the operation.

Parameters

  slot | A SlotAsyncReady to call when the request is satisfied.
  cancellable | A Cancellable object.

Since glibmm 2.36:

void Gio::UnixConnection::receive_credentials_async | ( | const SlotAsyncReady& | slot | ) |

A non-cancellable version of receive_credentials_async().

Glib::RefPtr<Credentials> Gio::UnixConnection::receive_credentials_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finishes an asynchronous receive credentials operation started with g_unix_connection_receive_credentials_async().

Since glibmm 2.32:

Parameters

  result | A AsyncResult.

Returns
  A Credentials, or `0` on error. Free the returned object with Glib::object_unref().

int Gio::UnixConnection::receive_fd | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives a file descriptor from the sending end of the connection.

The sending end has to call g_unix_connection_send_fd() for this to work.

As well as reading the fd this also reads a single byte from the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters

  cancellable | Optional Cancellable object, `0` to ignore.

Returns
  A file descriptor on success, -1 on error.

int Gio::UnixConnection::receive_fd | ( |  | ) |

A receive_fd() convenience overload.

bool Gio::UnixConnection::send_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Passes the credentials of the current user the receiving side of the connection.

The receiving end has to call g_unix_connection_receive_credentials() (or similar) to accept the credentials.

As well as sending the credentials this also writes a single NUL byte to the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters

  cancellable | A Cancellable or `0`.

Returns
  `true` on success, `false` if error is set.

bool Gio::UnixConnection::send_credentials | ( |  | ) |

A send_credentials() convenience overload.

void Gio::UnixConnection::send_credentials_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Asynchronously send credentials.

For more details, see send_credentials() which is the synchronous version of this call.

When the operation is finished, slot will be called. You can then call send_credentials_finish() to get the result of the operation.

Parameters

  slot | A SlotAsyncReady to call when the request is satisfied.
  cancellable | A Cancellable object.

Since glibmm 2.36:

void Gio::UnixConnection::send_credentials_async | ( | const SlotAsyncReady& | slot | ) |

A non-cancellable version of send_credentials_async().

bool Gio::UnixConnection::send_credentials_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Finishes an asynchronous send credentials operation started with g_unix_connection_send_credentials_async().

Since glibmm 2.32:

Parameters

  result | A AsyncResult.

Returns
  `true` if the operation was successful, otherwise `false`.

bool Gio::UnixConnection::send_fd | ( | int | fd,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Passes a file descriptor to the receiving side of the connection.

The receiving end has to call g_unix_connection_receive_fd() to accept the file descriptor.

As well as sending the fd this also writes a single byte to the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters

  fd | A file descriptor.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns
  A `true` on success, `0` on error.

bool Gio::UnixConnection::send_fd | ( | int | fd | ) |

A send_fd() convenience overload.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixConnection > wrap | ( | GUnixConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.